# Schoolkeep

Develop custom templates for your online school locally.

## Installation

1. Install Ruby version greater than or equal to 2.0
2. To install the command line execute

```bash
gem install schoolkeep
```

## Usage

For a good starting point building your templates, have a look at the ones we
use by default here:

https://github.com/SchoolKeep/sk-design


You can either clone/fork the repository or you can download it via this zip.

https://github.com/SchoolKeep/sk-design/archive/master.zip


### Local Development Commands

`sk server`

Hosts your local development environment at http://localhost:4000

This allows you to modify and develop your templates locally without having to
upload them to your school.

If activesupport is not installed automatic pluralization will not work accurately.
To install activesupport xcode commandline tools for OSX or ruby devkit for Windows is required.

----------

`sk generate-fixtures`

This command will generate local sample data at `config/fixtures.yml` to be
used with `sk server`. This sample data will not be uploaded to SchoolKeep and
is only for testing purposes within the local development environment.

We store this data in YAML format.  You can read more about YAML here https://github.com/darvid/trine/wiki/YAML-Primer

In order to reduce duplication in the fixtures any value that starts with a `:`
is a reference to a key under `models:`.

### Remote School Commands

In order to use these features you must set your `SK_API_KEY` environment variable with
the api key given from support. You can set `SK_API_KEY` by setting it in your
`.bash_profile` or in every command `SK_API_KEY=abc123 sk upload` where `upload` can
be any command and `abc123` is replaced by your API key.

`sk download-fixtures`

This command will download data from your online school to `config/fixtures.yml`
to be used with `sk server`. This sample data will not be uploaded to SchoolKeep
and is only for testing purposes within the local development environment.

`sk upload --all`

This command will upload all valid templates files in the `sk-design/templates`
folder and overwrite any old ones.  **THESE CHANGES WILL TAKE PLACE IMMEDIATELY**

`sk upload templates/custom_page.html.sktl`

This command will do the same as above but upload a single file

You should see output noting which files have been uploaded.  Once this has
completed, you can visit your live school and see the changes.

#### Error Messages

1. `invalid templates` - you have sktl in your templates folder that cannot be used.
2. `upload failed` - Either your connection is bad or something had happened on our servers.

-------

`sk reset --all`

This will reset all your styles and templates on your school.

`sk reset custom_page.html.sktl`

This will reset the specified single template. (directory will be ignored)

**THESE CHANGES WILL TAKE PLACE IMMEDIATELY**

## Contributing

1. Fork it ( https://github.com/SchoolKeep/schoolkeep-ruby/fork )
2. Create your feature branch (`git checkout -b my-new-feature`)
3. Commit your changes (`git commit -am 'Add some feature'`)
4. Push to the branch (`git push origin my-new-feature`)
5. Create a new Pull Request
