require "scribble"
require "schoolkeep/scribble/methods/query_parameter_value"

module Scribble::Methods
  RSpec.describe QueryParameterValue do
    describe "#query_parameter_value" do
      it "escapes HTML" do
        rendered = render("<input value='{{ query_parameter_value }}>'", "test_template")

        expect(rendered).to eq \
          "<input value='&#39;&gt;&lt;script&gt;alert(&#39;HAXXX&#39;)&lt;/script&gt;>'"
      end
    end

    def render(source, template_name, locale = :en)
      Scribble::Template.new(source).render(
        variables: {
          template_name: template_name,
          params: {
            q: "'><script>alert('HAXXX')</script>"
          }
        }
      )
    end
  end
end
