require "scribble"
require "schoolkeep/scribble/methods/t"

module Scribble::Methods
  RSpec.describe T do
    describe "#t" do
      it "delegates to I18n and allows for short keys" do
        foo_rendered = render("{{t('.foo')}}", "test_template")
        bar_rendered = render("{{t('bar')}}", "test_template")

        expect(foo_rendered).to eq "bar"
        expect(bar_rendered).to eq "baz"
      end

      context "when the template name has a locale suffix" do
        it "renders the correct translation" do
          foo_rendered = render("{{t('.foo')}}", "test_template.es", :es)
          bar_rendered = render("{{t('bar')}}", "test_template.es", :es)

          expect(foo_rendered).to eq "el_bar"
          expect(bar_rendered).to eq "el_baz"
        end
      end
    end

    def render(source, template_name, locale = :en)
      I18n.locale = locale
      Scribble::Template.new(source).render(
        variables: {template_name: template_name}
      )
    end
  end
end
