require "schoolkeep/views/asset_cache"

module Schoolkeep
  module Views
    RSpec.describe AssetCache do
      it "retreives full asset urls and only calls get once" do
        asset_cache = AssetCache.new("https://app.northpass.com")
        allow(asset_cache).to receive(:get) { "https://app.northpass.com/assets/sk-favicon.ico" }

        asset_url = asset_cache["/assets/sk-favicon.ico"]

        expect(asset_url).to eq("https://app.northpass.com/assets/sk-favicon.ico")
        expect(asset_cache["/assets/sk-favicon.ico"]).to eq asset_url
        expect(asset_cache).to have_received(:get).once
      end

      it "returns the asset path of an asset that is not found" do
        asset_cache = AssetCache.new("https://app.northpass.com")
        asset_url = asset_cache["/assets/not-found-image-test.png"]
        expect(asset_url).to eq "/assets/not-found-image-test.png"
      end
    end
  end
end
